"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const famous_1 = require("./famous");
function getVariableNameFromPackage(packageName) {
    packageName = packageName.toLowerCase();
    if (typeof famous_1.default[packageName] === "string") {
        return famous_1.default[packageName];
    }
    if (packageName[0] === "@") {
        packageName = packageName.slice(1);
    }
    packageName = packageName.replace(/[\.\-]js$/, "");
    packageName = packageName.replace(/^js-/, "");
    if (packageName.match(/^\w[\w\d]*$/)) {
        return packageName;
    }
    const dots = packageName.split(/[-\/]/);
    if (dots.length > 0) {
        packageName = dots[dots.length - 1];
    }
    const words = packageName.split("-").map((word, index) => {
        if (index === 0 || !word) {
            return word;
        }
        return word[0].toUpperCase() + word.slice(1);
    });
    return words.join("");
}
class Mod {
    constructor(target) {
        this.target = target;
        const versionIndex = target.lastIndexOf("@");
        if (versionIndex > 0) {
            this.packageName = target.slice(0, versionIndex);
        }
        else {
            this.packageName = target;
        }
        this.variableName = getVariableNameFromPackage(this.packageName);
    }
}
exports.Mod = Mod;
